searchData={"items":[{"type":"module","title":"Ecto.Adapters.Druid","doc":"This adapter allows you to use Druid as a database with Ecto.","ref":"Ecto.Adapters.Druid.html"},{"type":"module","title":"Installation - Ecto.Adapters.Druid","doc":"To use the Druid adapter, you need to add it to your `mix.exs` file:\n\n    defp deps do\n      [\n        {:ecto_adapters_druid, \"~> 0.1.0\"}\n      ]\n    end","ref":"Ecto.Adapters.Druid.html#module-installation"},{"type":"module","title":"Usage - Ecto.Adapters.Druid","doc":"You can now use Ecto with Druid by defining a repository that uses the Druid adapter:\n\n    defmodule MyApp.Repo do\n      use Ecto.Repo,\n        otp_app: :my_app,\n        adapter: Ecto.Adapters.Druid\n    end","ref":"Ecto.Adapters.Druid.html#module-usage"},{"type":"module","title":"Configuration - Ecto.Adapters.Druid","doc":"Then you need to configure your repository to use the Druid adapter:\n\n    config :my_app, MyApp.Repo,\n      host: \"localhost\",\n      port: 8082\n      finch_opts: [pools: %{default: [size: 10]}]\n\nThe following options are supported:\n\n* `:host` - The host of the Druid server.\n* `:port` - The port of the Druid server.\n* `:scheme` - The scheme of the Druid server (http or https).\n* `:finch_opts` - [Options](https://hexdocs.pm/finch/Finch.html#start_link/1-options) to pass to Finch when making requests to Druid.","ref":"Ecto.Adapters.Druid.html#module-configuration"},{"type":"module","title":"Ecto.Druid.Query","doc":"","ref":"Ecto.Druid.Query.html"},{"type":"macro","title":"Ecto.Druid.Query.abs/1","doc":"Absolute value.","ref":"Ecto.Druid.Query.html#abs/1"},{"type":"macro","title":"Ecto.Druid.Query.acos/1","doc":"Arc cosine of expr.","ref":"Ecto.Druid.Query.html#acos/1"},{"type":"macro","title":"Ecto.Druid.Query.any_value/1","doc":"Returns any value of expr including null. This aggregator can simplify and optimize the performance by returning the first encountered value (including null).\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValue is omitted; it defaults to 1024. aggregateMultipleValues is an optional boolean flag controls the behavior of aggregating a multi-value dimension. aggregateMultipleValues is set as true by default and returns the stringified array in case of a multi-value dimension. By setting it to false, function will return first value instead.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#any_value/1"},{"type":"macro","title":"Ecto.Druid.Query.any_value/2","doc":"Returns any value of expr including null. This aggregator can simplify and optimize the performance by returning the first encountered value (including null).\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValue is omitted; it defaults to 1024. aggregateMultipleValues is an optional boolean flag controls the behavior of aggregating a multi-value dimension. aggregateMultipleValues is set as true by default and returns the stringified array in case of a multi-value dimension. By setting it to false, function will return first value instead.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#any_value/2"},{"type":"macro","title":"Ecto.Druid.Query.any_value/3","doc":"Returns any value of expr including null. This aggregator can simplify and optimize the performance by returning the first encountered value (including null).\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValue is omitted; it defaults to 1024. aggregateMultipleValues is an optional boolean flag controls the behavior of aggregating a multi-value dimension. aggregateMultipleValues is set as true by default and returns the stringified array in case of a multi-value dimension. By setting it to false, function will return first value instead.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#any_value/3"},{"type":"macro","title":"Ecto.Druid.Query.approx_count_distinct/1","doc":"Counts distinct values of expr using an approximate algorithm. The expr can be a regular column or a prebuilt sketch column.\n\nThe specific algorithm depends on the value of druid.sql.approxCountDistinct.function. By default, this is APPROX_COUNT_DISTINCT_BUILTIN. If the DataSketches extension is loaded, you can set it to APPROX_COUNT_DISTINCT_DS_HLL or APPROX_COUNT_DISTINCT_DS_THETA.\n\nWhen run on prebuilt sketch columns, the sketch column type must match the implementation of this function. For example: when druid.sql.approxCountDistinct.function is set to APPROX_COUNT_DISTINCT_BUILTIN, this function runs on prebuilt hyperUnique columns, but not on prebuilt HLLSketchBuild columns.","ref":"Ecto.Druid.Query.html#approx_count_distinct/1"},{"type":"macro","title":"Ecto.Druid.Query.approx_count_distinct_builtin/1","doc":"Usage note: consider using APPROX_COUNT_DISTINCT_DS_HLL instead, which offers better accuracy in many cases.\nCounts distinct values of expr using Druid's built-in \"cardinality\" or \"hyperUnique\" aggregators, which implement a variant of HyperLogLog. The expr can be a string, a number, or a prebuilt hyperUnique column. Results are always approximate, regardless of the value of useApproximateCountDistinct.","ref":"Ecto.Druid.Query.html#approx_count_distinct_builtin/1"},{"type":"macro","title":"Ecto.Druid.Query.approx_count_distinct_ds_theta/1","doc":"Counts distinct values of expr, which can be a regular column or a Theta sketch column. Results are always approximate, regardless of the value of useApproximateCountDistinct. The size parameter is described in the Theta sketch documentation. See also COUNT(DISTINCT expr).","ref":"Ecto.Druid.Query.html#approx_count_distinct_ds_theta/1"},{"type":"macro","title":"Ecto.Druid.Query.approx_count_distinct_ds_theta/2","doc":"Counts distinct values of expr, which can be a regular column or a Theta sketch column. Results are always approximate, regardless of the value of useApproximateCountDistinct. The size parameter is described in the Theta sketch documentation. See also COUNT(DISTINCT expr).","ref":"Ecto.Druid.Query.html#approx_count_distinct_ds_theta/2"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile/2","doc":"Deprecated. Use APPROX_QUANTILE_DS instead, which provides a superior distribution-independent algorithm with formal error guarantees.\n\nComputes approximate quantiles on numeric or approxHistogram expressions. probability should be between 0 and 1, exclusive. resolution is the number of centroids to use for the computation. Higher resolutions will give more precise results but also have higher overhead. If not provided, the default resolution is 50. Load the approximate histogram extension to use this function.","ref":"Ecto.Druid.Query.html#approx_quantile/2"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile/3","doc":"Deprecated. Use APPROX_QUANTILE_DS instead, which provides a superior distribution-independent algorithm with formal error guarantees.\n\nComputes approximate quantiles on numeric or approxHistogram expressions. probability should be between 0 and 1, exclusive. resolution is the number of centroids to use for the computation. Higher resolutions will give more precise results but also have higher overhead. If not provided, the default resolution is 50. Load the approximate histogram extension to use this function.","ref":"Ecto.Druid.Query.html#approx_quantile/3"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile_ds/2","doc":"Computes approximate quantiles on numeric or Quantiles sketch expressions. The probability value should be between 0 and 1, exclusive. The k parameter is described in the Quantiles sketch documentation.","ref":"Ecto.Druid.Query.html#approx_quantile_ds/2"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile_ds/3","doc":"Computes approximate quantiles on numeric or Quantiles sketch expressions. The probability value should be between 0 and 1, exclusive. The k parameter is described in the Quantiles sketch documentation.","ref":"Ecto.Druid.Query.html#approx_quantile_ds/3"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile_fixed_buckets/5","doc":"Computes approximate quantiles on numeric or fixed buckets histogram expressions. probability should be between 0 and 1, exclusive. The numBuckets, lowerLimit, upperLimit, and outlierHandlingMode parameters are described in the fixed buckets histogram documentation. Load the approximate histogram extension to use this function.","ref":"Ecto.Druid.Query.html#approx_quantile_fixed_buckets/5"},{"type":"macro","title":"Ecto.Druid.Query.approx_quantile_fixed_buckets/6","doc":"Computes approximate quantiles on numeric or fixed buckets histogram expressions. probability should be between 0 and 1, exclusive. The numBuckets, lowerLimit, upperLimit, and outlierHandlingMode parameters are described in the fixed buckets histogram documentation. Load the approximate histogram extension to use this function.","ref":"Ecto.Druid.Query.html#approx_quantile_fixed_buckets/6"},{"type":"macro","title":"Ecto.Druid.Query.array/1","doc":"Constructs a SQL ARRAY literal from the expression arguments, using the type of the first argument as the output array type.","ref":"Ecto.Druid.Query.html#array/1"},{"type":"macro","title":"Ecto.Druid.Query.array_agg/1","doc":"Collects all values of expr into an ARRAY, including null values, with size in bytes limit on aggregation size (default of 1024 bytes). If the aggregated array grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the ARRAY_AGG expression is not currently supported, and the ordering of results within the output array may vary depending on processing order.","ref":"Ecto.Druid.Query.html#array_agg/1"},{"type":"macro","title":"Ecto.Druid.Query.array_agg/2","doc":"Collects all values of expr into an ARRAY, including null values, with size in bytes limit on aggregation size (default of 1024 bytes). If the aggregated array grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the ARRAY_AGG expression is not currently supported, and the ordering of results within the output array may vary depending on processing order.","ref":"Ecto.Druid.Query.html#array_agg/2"},{"type":"macro","title":"Ecto.Druid.Query.array_append/2","doc":"Appends expr to arr, the resulting array type determined by the type of arr.","ref":"Ecto.Druid.Query.html#array_append/2"},{"type":"macro","title":"Ecto.Druid.Query.array_concat/2","doc":"Concatenates arr2 to arr1. The resulting array type is determined by the type of arr1.","ref":"Ecto.Druid.Query.html#array_concat/2"},{"type":"macro","title":"Ecto.Druid.Query.array_concat_agg/1","doc":"Concatenates all array expr into a single ARRAY, with size in bytes limit on aggregation size (default of 1024 bytes). Input expr must be an array. Null expr will be ignored, but any null values within an expr will be included in the resulting array. If the aggregated array grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the ARRAY_CONCAT_AGG expression is not currently supported, and the ordering of results within the output array may vary depending on processing order.","ref":"Ecto.Druid.Query.html#array_concat_agg/1"},{"type":"macro","title":"Ecto.Druid.Query.array_concat_agg/2","doc":"Concatenates all array expr into a single ARRAY, with size in bytes limit on aggregation size (default of 1024 bytes). Input expr must be an array. Null expr will be ignored, but any null values within an expr will be included in the resulting array. If the aggregated array grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the ARRAY_CONCAT_AGG expression is not currently supported, and the ordering of results within the output array may vary depending on processing order.","ref":"Ecto.Druid.Query.html#array_concat_agg/2"},{"type":"macro","title":"Ecto.Druid.Query.array_contains/2","doc":"If expr is a scalar type, returns 1 if arr contains expr. If expr is an array, returns 1 if arr contains all elements of expr. Otherwise returns 0.","ref":"Ecto.Druid.Query.html#array_contains/2"},{"type":"macro","title":"Ecto.Druid.Query.array_length/1","doc":"Returns length of the array expression.","ref":"Ecto.Druid.Query.html#array_length/1"},{"type":"macro","title":"Ecto.Druid.Query.array_offset/2","doc":"Returns the array element at the 0-based index supplied, or null for an out of range index.","ref":"Ecto.Druid.Query.html#array_offset/2"},{"type":"macro","title":"Ecto.Druid.Query.array_offset_of/2","doc":"Returns the 0-based index of the first occurrence of expr in the array. If no matching elements exist in the array, returns null or -1 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode).","ref":"Ecto.Druid.Query.html#array_offset_of/2"},{"type":"macro","title":"Ecto.Druid.Query.array_ordinal/2","doc":"Returns the array element at the 1-based index supplied, or null for an out of range index.","ref":"Ecto.Druid.Query.html#array_ordinal/2"},{"type":"macro","title":"Ecto.Druid.Query.array_ordinal_of/2","doc":"Returns the 1-based index of the first occurrence of expr in the array. If no matching elements exist in the array, returns null or -1 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode).","ref":"Ecto.Druid.Query.html#array_ordinal_of/2"},{"type":"macro","title":"Ecto.Druid.Query.array_overlap/2","doc":"Returns 1 if arr1 and arr2 have any elements in common, else 0.","ref":"Ecto.Druid.Query.html#array_overlap/2"},{"type":"macro","title":"Ecto.Druid.Query.array_prepend/2","doc":"Adds expr to the beginning of arr, the resulting array type determined by the type of arr.","ref":"Ecto.Druid.Query.html#array_prepend/2"},{"type":"macro","title":"Ecto.Druid.Query.array_slice/3","doc":"Returns the subarray of arr from the 0-based index start (inclusive) to end (exclusive). Returns null, if start is less than 0, greater than length of arr, or greater than end.","ref":"Ecto.Druid.Query.html#array_slice/3"},{"type":"macro","title":"Ecto.Druid.Query.array_to_mv/1","doc":"Converts an ARRAY of any type into a multi-value string VARCHAR.","ref":"Ecto.Druid.Query.html#array_to_mv/1"},{"type":"macro","title":"Ecto.Druid.Query.array_to_string/2","doc":"Joins all elements of arr by the delimiter specified by str.","ref":"Ecto.Druid.Query.html#array_to_string/2"},{"type":"macro","title":"Ecto.Druid.Query.asin/1","doc":"Arc sine of expr.","ref":"Ecto.Druid.Query.html#asin/1"},{"type":"macro","title":"Ecto.Druid.Query.atan2/2","doc":"Angle theta from the conversion of rectangular coordinates (x, y) to polar coordinates (r, theta).","ref":"Ecto.Druid.Query.html#atan2/2"},{"type":"macro","title":"Ecto.Druid.Query.atan/1","doc":"Arc tangent of expr.","ref":"Ecto.Druid.Query.html#atan/1"},{"type":"macro","title":"Ecto.Druid.Query.bit_and/1","doc":"Performs a bitwise AND operation on all input values.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#bit_and/1"},{"type":"macro","title":"Ecto.Druid.Query.bit_or/1","doc":"Performs a bitwise OR operation on all input values.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#bit_or/1"},{"type":"macro","title":"Ecto.Druid.Query.bit_xor/1","doc":"Performs a bitwise XOR operation on all input values.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#bit_xor/1"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_and/2","doc":"Returns the result of expr1 & expr2.","ref":"Ecto.Druid.Query.html#bitwise_and/2"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_complement/1","doc":"Returns the result of ~expr.","ref":"Ecto.Druid.Query.html#bitwise_complement/1"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_convert_double_to_long_bits/1","doc":"Converts the bits of an IEEE 754 floating-point double value to a long.","ref":"Ecto.Druid.Query.html#bitwise_convert_double_to_long_bits/1"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_convert_long_bits_to_double/1","doc":"Converts a long to the IEEE 754 floating-point double specified by the bits stored in the long.","ref":"Ecto.Druid.Query.html#bitwise_convert_long_bits_to_double/1"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_or/2","doc":"Returns the result of expr1 [PIPE] expr2.","ref":"Ecto.Druid.Query.html#bitwise_or/2"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_shift_left/2","doc":"Returns the result of expr1 << expr2.","ref":"Ecto.Druid.Query.html#bitwise_shift_left/2"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_shift_right/2","doc":"Returns the result of expr1 >> expr2.","ref":"Ecto.Druid.Query.html#bitwise_shift_right/2"},{"type":"macro","title":"Ecto.Druid.Query.bitwise_xor/2","doc":"Returns the result of expr1 ^ expr2.","ref":"Ecto.Druid.Query.html#bitwise_xor/2"},{"type":"macro","title":"Ecto.Druid.Query.bloom_filter/2","doc":"Computes a bloom filter from values produced by expr, with numEntries maximum number of distinct values before false positive rate increases. See bloom filter extension documentation for additional details.\tEmpty base64 encoded bloom filter","ref":"Ecto.Druid.Query.html#bloom_filter/2"},{"type":"macro","title":"Ecto.Druid.Query.bloom_filter_test/2","doc":"Returns true if the value of expr is contained in the base64-serialized Bloom filter. See the Bloom filter extension documentation for additional details. See the BLOOM_FILTER function for computing Bloom filters.","ref":"Ecto.Druid.Query.html#bloom_filter_test/2"},{"type":"macro","title":"Ecto.Druid.Query.btrim/1","doc":"Alternate form of TRIM(BOTH chars FROM expr).","ref":"Ecto.Druid.Query.html#btrim/1"},{"type":"macro","title":"Ecto.Druid.Query.btrim/2","doc":"Alternate form of TRIM(BOTH chars FROM expr).","ref":"Ecto.Druid.Query.html#btrim/2"},{"type":"macro","title":"Ecto.Druid.Query.ceil/1","doc":"Ceiling.","ref":"Ecto.Druid.Query.html#ceil/1"},{"type":"macro","title":"Ecto.Druid.Query.ceil/2","doc":"Rounds up a timestamp, returning it as a new timestamp. Unit can be SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or YEAR.","ref":"Ecto.Druid.Query.html#ceil/2"},{"type":"macro","title":"Ecto.Druid.Query.char_length/1","doc":"Alias for LENGTH.","ref":"Ecto.Druid.Query.html#char_length/1"},{"type":"macro","title":"Ecto.Druid.Query.character_length/1","doc":"Alias for LENGTH.","ref":"Ecto.Druid.Query.html#character_length/1"},{"type":"macro","title":"Ecto.Druid.Query.coalesce/1","doc":"Returns the first value that is neither NULL nor empty string.","ref":"Ecto.Druid.Query.html#coalesce/1"},{"type":"macro","title":"Ecto.Druid.Query.concat/1","doc":"Concats a list of expressions.","ref":"Ecto.Druid.Query.html#concat/1"},{"type":"macro","title":"Ecto.Druid.Query.contains_string/2","doc":"Returns true if the str is a substring of expr.","ref":"Ecto.Druid.Query.html#contains_string/2"},{"type":"macro","title":"Ecto.Druid.Query.cos/1","doc":"Trigonometric cosine of an angle expr.","ref":"Ecto.Druid.Query.html#cos/1"},{"type":"macro","title":"Ecto.Druid.Query.cot/1","doc":"Trigonometric cotangent of an angle expr.","ref":"Ecto.Druid.Query.html#cot/1"},{"type":"macro","title":"Ecto.Druid.Query.current_date/0","doc":"Current date in the connection's time zone.","ref":"Ecto.Druid.Query.html#current_date/0"},{"type":"macro","title":"Ecto.Druid.Query.current_timestamp/0","doc":"Current timestamp in the connection's time zone.","ref":"Ecto.Druid.Query.html#current_timestamp/0"},{"type":"macro","title":"Ecto.Druid.Query.date_trunc/2","doc":"Rounds down a timestamp, returning it as a new timestamp. Unit can be 'milliseconds', 'second', 'minute', 'hour', 'day', 'week', 'month', 'quarter', 'year', 'decade', 'century', or 'millennium'.","ref":"Ecto.Druid.Query.html#date_trunc/2"},{"type":"macro","title":"Ecto.Druid.Query.decode_base64_complex/2","doc":"Decodes a Base64-encoded string into a complex data type, where dataType is the complex data type and expr is the Base64-encoded string to decode. The hyperUnique and serializablePairLongString data types are supported by default. You can enable support for the following complex data types by loading their extensions: druid-bloom-filter: bloom druid-datasketches: arrayOfDoublesSketch, HLLSketch, KllDoublesSketch, KllFloatsSketch, quantilesDoublesSketch, thetaSketch druid-histogram: approximateHistogram, fixedBucketsHistogram druid-stats: variance druid-compressed-big-decimal: compressedBigDecimal druid-momentsketch: momentSketch druid-tdigestsketch: tDigestSketch\n\n  druid-bloom-filter: bloom\n  druid-datasketches: arrayOfDoublesSketch, HLLSketch, KllDoublesSketch, KllFloatsSketch, quantilesDoublesSketch, thetaSketch\n  druid-histogram: approximateHistogram, fixedBucketsHistogram\n  druid-stats: variance\n  druid-compressed-big-decimal: compressedBigDecimal\n  druid-momentsketch: momentSketch\n  druid-tdigestsketch: tDigestSketch","ref":"Ecto.Druid.Query.html#decode_base64_complex/2"},{"type":"macro","title":"Ecto.Druid.Query.decode_base64_utf8/1","doc":"Decodes a Base64-encoded string into a UTF-8 encoded string.","ref":"Ecto.Druid.Query.html#decode_base64_utf8/1"},{"type":"macro","title":"Ecto.Druid.Query.degrees/1","doc":"Converts an angle measured in radians to an approximately equivalent angle measured in degrees.","ref":"Ecto.Druid.Query.html#degrees/1"},{"type":"macro","title":"Ecto.Druid.Query.distinct/1","doc":"Applies DISTINCT modifier to expr.","ref":"Ecto.Druid.Query.html#distinct/1"},{"type":"macro","title":"Ecto.Druid.Query.div/2","doc":"Returns the result of integer division of x by y","ref":"Ecto.Druid.Query.html#div/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_cdf/2","doc":"Returns a string representing approximation to the Cumulative Distribution Function given a list of split points that define the edges of the bins from a quantiles sketch. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_cdf/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_get_quantile/2","doc":"Returns the quantile estimate corresponding to fraction from a quantiles sketch. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_get_quantile/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_get_quantiles/2","doc":"Returns a string representing an array of quantile estimates corresponding to a list of fractions from a quantiles sketch. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_get_quantiles/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_histogram/2","doc":"Returns a string representing an approximation to the histogram given a list of split points that define the histogram bins from a quantiles sketch. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_histogram/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_quantile_summary/1","doc":"Returns a string summary of a quantiles sketch, useful for debugging. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_quantile_summary/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_quantiles_sketch/1","doc":"Creates a Quantiles sketch on the values of expr, which can be a regular column or a column containing quantiles sketches. The k parameter is described in the Quantiles sketch documentation.","ref":"Ecto.Druid.Query.html#ds_quantiles_sketch/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_quantiles_sketch/2","doc":"Creates a Quantiles sketch on the values of expr, which can be a regular column or a column containing quantiles sketches. The k parameter is described in the Quantiles sketch documentation.","ref":"Ecto.Druid.Query.html#ds_quantiles_sketch/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_rank/2","doc":"Returns an approximation to the rank of a given value that is the fraction of the distribution less than that value from a quantiles sketch. expr must return a quantiles sketch.","ref":"Ecto.Druid.Query.html#ds_rank/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_theta/1","doc":"Creates a Theta sketch on the values of expr, which can be a regular column or a column containing Theta sketches. The size parameter is described in the Theta sketch documentation.","ref":"Ecto.Druid.Query.html#ds_theta/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_theta/2","doc":"Creates a Theta sketch on the values of expr, which can be a regular column or a column containing Theta sketches. The size parameter is described in the Theta sketch documentation.","ref":"Ecto.Druid.Query.html#ds_theta/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles/1","doc":"Creates a Tuple sketch on the values of expr, which can be a regular column or a column containing tuple sketches. The k parameter is described in the Tuple sketch documentation.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles/2","doc":"Creates a Tuple sketch on the values of expr, which can be a regular column or a column containing tuple sketches. The k parameter is described in the Tuple sketch documentation.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_intersect/1","doc":"Returns an intersection of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Objects are summed when combined. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_intersect/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_intersect/2","doc":"Returns an intersection of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Objects are summed when combined. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_intersect/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_metrics_sum_estimate/1","doc":"Computes approximate sums of the values contained within a Tuple sketch column which contains an array of double values as its Summary Object.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_metrics_sum_estimate/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_not/1","doc":"Returns a set difference of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Object are preserved as is. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_not/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_not/2","doc":"Returns a set difference of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Object are preserved as is. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_not/2"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_union/1","doc":"Returns a union of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Objects are summed when combined. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_union/1"},{"type":"macro","title":"Ecto.Druid.Query.ds_tuple_doubles_union/2","doc":"Returns a union of tuple sketches, where each input expression must return a tuple sketch which contains an array of double values as its Summary Object. The values contained in the Summary Objects are summed when combined. If the last value of the array is a numeric literal, Druid assumes that the value is an override parameter for nominal entries.","ref":"Ecto.Druid.Query.html#ds_tuple_doubles_union/2"},{"type":"macro","title":"Ecto.Druid.Query.earliest/1","doc":"Returns the earliest value of expr.\nIf expr comes from a relation with a timestamp column (like __time in a Druid datasource), the \"earliest\" is taken from the row with the overall earliest non-null value of the timestamp column.\nIf the earliest non-null value of the timestamp column appears in multiple rows, the expr may be taken from any of those rows. If expr does not come from a relation with a timestamp, then it is simply the first value encountered.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#earliest/1"},{"type":"macro","title":"Ecto.Druid.Query.earliest/2","doc":"Returns the earliest value of expr.\nIf expr comes from a relation with a timestamp column (like __time in a Druid datasource), the \"earliest\" is taken from the row with the overall earliest non-null value of the timestamp column.\nIf the earliest non-null value of the timestamp column appears in multiple rows, the expr may be taken from any of those rows. If expr does not come from a relation with a timestamp, then it is simply the first value encountered.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#earliest/2"},{"type":"macro","title":"Ecto.Druid.Query.earliest_by/2","doc":"Returns the earliest value of expr.\nThe earliest value of expr is taken from the row with the overall earliest non-null value of timestampExpr.\nIf the earliest non-null value of timestampExpr appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\n\nUse EARLIEST instead of EARLIEST_BY on a table that has rollup enabled and was created with any variant of EARLIEST, LATEST, EARLIEST_BY, or LATEST_BY. In these cases, the intermediate type already stores the timestamp, and Druid ignores the value passed in timestampExpr.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#earliest_by/2"},{"type":"macro","title":"Ecto.Druid.Query.earliest_by/3","doc":"Returns the earliest value of expr.\nThe earliest value of expr is taken from the row with the overall earliest non-null value of timestampExpr.\nIf the overall earliest non-null value of timestampExpr appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\n\nUse EARLIEST instead of EARLIEST_BY on a table that has rollup enabled and was created with any variant of EARLIEST, LATEST, EARLIEST_BY, or LATEST_BY. In these cases, the intermediate type already stores the timestamp, and Druid ignores the value passed in timestampExpr.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#earliest_by/3"},{"type":"macro","title":"Ecto.Druid.Query.exp/1","doc":"e to the power of expr.","ref":"Ecto.Druid.Query.html#exp/1"},{"type":"macro","title":"Ecto.Druid.Query.extern/3","doc":"","ref":"Ecto.Druid.Query.html#extern/3"},{"type":"macro","title":"Ecto.Druid.Query.extract/2","doc":"Extracts a time part from expr, returning it as a number. Unit can be EPOCH, MICROSECOND, MILLISECOND, SECOND, MINUTE, HOUR, DAY, DOW (day of week), ISODOW (ISO day of week), DOY (day of year), WEEK (week of year), MONTH, QUARTER, YEAR, ISOYEAR, DECADE, CENTURY or MILLENNIUM. Units must be provided unquoted, like EXTRACT(HOUR FROM __time).","ref":"Ecto.Druid.Query.html#extract/2"},{"type":"macro","title":"Ecto.Druid.Query.floor/1","doc":"Floor.","ref":"Ecto.Druid.Query.html#floor/1"},{"type":"macro","title":"Ecto.Druid.Query.floor/2","doc":"Rounds down a timestamp, returning it as a new timestamp. Unit can be SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or YEAR.","ref":"Ecto.Druid.Query.html#floor/2"},{"type":"macro","title":"Ecto.Druid.Query.greatest/1","doc":"Evaluates zero or more expressions and returns the maximum value based on comparisons as described above.","ref":"Ecto.Druid.Query.html#greatest/1"},{"type":"macro","title":"Ecto.Druid.Query.grouping/1","doc":"Returns a number to indicate which groupBy dimension is included in a row, when using GROUPING SETS. Refer to additional documentation on how to infer this number.","ref":"Ecto.Druid.Query.html#grouping/1"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_estimate/1","doc":"Returns the distinct count estimate from an HLL sketch. expr must return an HLL sketch. The optional round boolean parameter will round the estimate if set to true, with a default of false.","ref":"Ecto.Druid.Query.html#hll_sketch_estimate/1"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_estimate/2","doc":"Returns the distinct count estimate from an HLL sketch. expr must return an HLL sketch. The optional round boolean parameter will round the estimate if set to true, with a default of false.","ref":"Ecto.Druid.Query.html#hll_sketch_estimate/2"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_estimate_with_error_bounds/1","doc":"Returns the distinct count estimate and error bounds from an HLL sketch. expr must return an HLL sketch. An optional numStdDev argument can be provided.","ref":"Ecto.Druid.Query.html#hll_sketch_estimate_with_error_bounds/1"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_estimate_with_error_bounds/2","doc":"Returns the distinct count estimate and error bounds from an HLL sketch. expr must return an HLL sketch. An optional numStdDev argument can be provided.","ref":"Ecto.Druid.Query.html#hll_sketch_estimate_with_error_bounds/2"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_to_string/1","doc":"Returns a human-readable string representation of an HLL sketch for debugging. expr must return an HLL sketch.","ref":"Ecto.Druid.Query.html#hll_sketch_to_string/1"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_union/1","doc":"Returns a union of HLL sketches, where each input expression must return an HLL sketch. The lgK and tgtHllType can be optionally specified as the first parameter; if provided, both optional parameters must be specified.","ref":"Ecto.Druid.Query.html#hll_sketch_union/1"},{"type":"macro","title":"Ecto.Druid.Query.hll_sketch_union/3","doc":"Returns a union of HLL sketches, where each input expression must return an HLL sketch. The lgK and tgtHllType can be optionally specified as the first parameter; if provided, both optional parameters must be specified.","ref":"Ecto.Druid.Query.html#hll_sketch_union/3"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_binary_byte_format/1","doc":"Format a number in human-readable IEC format.","ref":"Ecto.Druid.Query.html#human_readable_binary_byte_format/1"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_binary_byte_format/2","doc":"Format a number in human-readable IEC format.","ref":"Ecto.Druid.Query.html#human_readable_binary_byte_format/2"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_decimal_byte_format/1","doc":"Format a number in human-readable SI format.","ref":"Ecto.Druid.Query.html#human_readable_decimal_byte_format/1"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_decimal_byte_format/2","doc":"Format a number in human-readable SI format.","ref":"Ecto.Druid.Query.html#human_readable_decimal_byte_format/2"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_decimal_format/1","doc":"Format a number in human-readable SI format.","ref":"Ecto.Druid.Query.html#human_readable_decimal_format/1"},{"type":"macro","title":"Ecto.Druid.Query.human_readable_decimal_format/2","doc":"Format a number in human-readable SI format.","ref":"Ecto.Druid.Query.html#human_readable_decimal_format/2"},{"type":"macro","title":"Ecto.Druid.Query.icontains_string/2","doc":"Returns true if the str is a substring of expr. The match is case-insensitive.","ref":"Ecto.Druid.Query.html#icontains_string/2"},{"type":"macro","title":"Ecto.Druid.Query.interval/2","doc":"","ref":"Ecto.Druid.Query.html#interval/2"},{"type":"macro","title":"Ecto.Druid.Query.ipv4_match/2","doc":"Returns true if the address belongs to the subnet literal, else false. If address is not a valid IPv4 address, then false is returned. This function is more efficient if address is an integer instead of a string.","ref":"Ecto.Druid.Query.html#ipv4_match/2"},{"type":"macro","title":"Ecto.Druid.Query.ipv4_parse/1","doc":"Parses address into an IPv4 address stored as an integer . If address is an integer that is a valid IPv4 address, then it is passed through. Returns null if address cannot be represented as an IPv4 address.","ref":"Ecto.Druid.Query.html#ipv4_parse/1"},{"type":"macro","title":"Ecto.Druid.Query.ipv4_stringify/1","doc":"Converts address into an IPv4 address dotted-decimal string. If address is a string that is a valid IPv4 address, then it is passed through. Returns null if address cannot be represented as an IPv4 address.","ref":"Ecto.Druid.Query.html#ipv4_stringify/1"},{"type":"macro","title":"Ecto.Druid.Query.ipv6_match/2","doc":"Returns 1 if the IPv6 address belongs to the subnet literal, else 0. If address is not a valid IPv6 address, then 0 is returned.","ref":"Ecto.Druid.Query.html#ipv6_match/2"},{"type":"macro","title":"Ecto.Druid.Query.json_keys/2","doc":"Returns an array of field names from expr at the specified path.","ref":"Ecto.Druid.Query.html#json_keys/2"},{"type":"macro","title":"Ecto.Druid.Query.json_object/1","doc":"Constructs a new COMPLEX  object. The KEY expressions must evaluate to string types. The VALUE expressions can be composed of any input type, including other COMPLEX  values. JSON_OBJECT can accept colon-separated key-value pairs. The following syntax is equivalent: JSON_OBJECT(expr1:expr2[, expr3:expr4, ...]).","ref":"Ecto.Druid.Query.html#json_object/1"},{"type":"macro","title":"Ecto.Druid.Query.json_paths/1","doc":"Returns an array of all paths which refer to literal values in expr in JSONPath format.","ref":"Ecto.Druid.Query.html#json_paths/1"},{"type":"macro","title":"Ecto.Druid.Query.json_query/2","doc":"Extracts a COMPLEX  value from expr, at the specified path.","ref":"Ecto.Druid.Query.html#json_query/2"},{"type":"macro","title":"Ecto.Druid.Query.json_query_array/2","doc":"Extracts an ARRAY > value from expr at the specified path. If value is not an ARRAY, it gets translated into a single element ARRAY containing the value at path. The primary use of this function is to extract arrays of objects to use as inputs to other array functions.","ref":"Ecto.Druid.Query.html#json_query_array/2"},{"type":"macro","title":"Ecto.Druid.Query.json_value/2","doc":"Extracts a literal value from expr at the specified path. If you specify RETURNING and an SQL type name (such as VARCHAR, BIGINT, DOUBLE, etc) the function plans the query using the suggested type. Otherwise, it attempts to infer the type based on the context. If it can't infer the type, it defaults to VARCHAR.","ref":"Ecto.Druid.Query.html#json_value/2"},{"type":"macro","title":"Ecto.Druid.Query.json_value/3","doc":"Extracts a literal value from expr at the specified path. If you specify RETURNING and an SQL type name (such as VARCHAR, BIGINT, DOUBLE, etc) the function plans the query using the suggested type. Otherwise, it attempts to infer the type based on the context. If it can't infer the type, it defaults to VARCHAR.","ref":"Ecto.Druid.Query.html#json_value/3"},{"type":"macro","title":"Ecto.Druid.Query.latest/1","doc":"Returns the latest value of expr\nThe expr must come from a relation with a timestamp column (like __time in a Druid datasource) and the \"latest\" is taken from the row with the overall latest non-null value of the timestamp column.\nIf the latest non-null value of the timestamp column appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#latest/1"},{"type":"macro","title":"Ecto.Druid.Query.latest/2","doc":"Returns the latest value of expr\nThe expr must come from a relation with a timestamp column (like __time in a Druid datasource) and the \"latest\" is taken from the row with the overall latest non-null value of the timestamp column.\nIf the latest non-null value of the timestamp column appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#latest/2"},{"type":"macro","title":"Ecto.Druid.Query.latest_by/2","doc":"Returns the latest value of expr\nThe latest value of expr is taken from the row with the overall latest non-null value of timestampExpr.\nIf the overall latest non-null value of timestampExpr appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\n\nUse LATEST instead of LATEST_BY on a table that has rollup enabled and was created with any variant of EARLIEST, LATEST, EARLIEST_BY, or LATEST_BY. In these cases, the intermediate type already stores the timestamp, and Druid ignores the value passed in timestampExpr.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#latest_by/2"},{"type":"macro","title":"Ecto.Druid.Query.latest_by/3","doc":"Returns the latest value of expr\nThe latest value of expr is taken from the row with the overall latest non-null value of timestampExpr.\nIf the overall latest non-null value of timestampExpr appears in multiple rows, the expr may be taken from any of those rows.\n\nIf expr is a string or complex type maxBytesPerValue amount of space is allocated for the aggregation. Strings longer than this limit are truncated. The maxBytesPerValue parameter should be set as low as possible, since high values will lead to wasted memory.\nIf maxBytesPerValueis omitted; it defaults to 1024.\n\nUse LATEST instead of LATEST_BY on a table that has rollup enabled and was created with any variant of EARLIEST, LATEST, EARLIEST_BY, or LATEST_BY. In these cases, the intermediate type already stores the timestamp, and Druid ignores the value passed in timestampExpr.\tnull or 0/'' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#latest_by/3"},{"type":"macro","title":"Ecto.Druid.Query.least/1","doc":"Evaluates zero or more expressions and returns the minimum value based on comparisons as described above.","ref":"Ecto.Druid.Query.html#least/1"},{"type":"macro","title":"Ecto.Druid.Query.left/1","doc":"Returns the leftmost length characters from expr.","ref":"Ecto.Druid.Query.html#left/1"},{"type":"macro","title":"Ecto.Druid.Query.left/2","doc":"Returns the leftmost length characters from expr.","ref":"Ecto.Druid.Query.html#left/2"},{"type":"macro","title":"Ecto.Druid.Query.length/1","doc":"Length of expr in UTF-16 code units.","ref":"Ecto.Druid.Query.html#length/1"},{"type":"macro","title":"Ecto.Druid.Query.listagg/1","doc":"Synonym for STRING_AGG.\tnull or '' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#listagg/1"},{"type":"macro","title":"Ecto.Druid.Query.listagg/2","doc":"Synonym for STRING_AGG.\tnull or '' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#listagg/2"},{"type":"macro","title":"Ecto.Druid.Query.listagg/3","doc":"Synonym for STRING_AGG.\tnull or '' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#listagg/3"},{"type":"macro","title":"Ecto.Druid.Query.ln/1","doc":"Logarithm (base e).","ref":"Ecto.Druid.Query.html#ln/1"},{"type":"macro","title":"Ecto.Druid.Query.log10/1","doc":"Logarithm (base 10).","ref":"Ecto.Druid.Query.html#log10/1"},{"type":"macro","title":"Ecto.Druid.Query.lookup/2","doc":"Look up expr in a registered query-time lookup table. Note that lookups can also be queried directly using the lookup schema. Optional constant replaceMissingValueWith can be passed as a third argument to be returned when value is missing from lookup.","ref":"Ecto.Druid.Query.html#lookup/2"},{"type":"macro","title":"Ecto.Druid.Query.lookup/3","doc":"Look up expr in a registered query-time lookup table. Note that lookups can also be queried directly using the lookup schema. Optional constant replaceMissingValueWith can be passed as a third argument to be returned when value is missing from lookup.","ref":"Ecto.Druid.Query.html#lookup/3"},{"type":"macro","title":"Ecto.Druid.Query.lower/1","doc":"Returns expr in all lowercase.","ref":"Ecto.Druid.Query.html#lower/1"},{"type":"macro","title":"Ecto.Druid.Query.lpad/2","doc":"Returns a string of length from expr left-padded with chars. If length is shorter than the length of expr, the result is expr which is truncated to length. The result will be null if either expr or chars is null. If chars is an empty string, no padding is added, however expr may be trimmed if necessary.","ref":"Ecto.Druid.Query.html#lpad/2"},{"type":"macro","title":"Ecto.Druid.Query.lpad/3","doc":"Returns a string of length from expr left-padded with chars. If length is shorter than the length of expr, the result is expr which is truncated to length. The result will be null if either expr or chars is null. If chars is an empty string, no padding is added, however expr may be trimmed if necessary.","ref":"Ecto.Druid.Query.html#lpad/3"},{"type":"macro","title":"Ecto.Druid.Query.ltrim/1","doc":"Alternate form of TRIM(LEADING chars FROM expr).","ref":"Ecto.Druid.Query.html#ltrim/1"},{"type":"macro","title":"Ecto.Druid.Query.ltrim/2","doc":"Alternate form of TRIM(LEADING chars FROM expr).","ref":"Ecto.Druid.Query.html#ltrim/2"},{"type":"macro","title":"Ecto.Druid.Query.millis_to_timestamp/1","doc":"Converts a number of milliseconds since the epoch (1970-01-01 00:00:00 UTC) into a timestamp.","ref":"Ecto.Druid.Query.html#millis_to_timestamp/1"},{"type":"macro","title":"Ecto.Druid.Query.mod/2","doc":"Modulo (remainder of x divided by y).","ref":"Ecto.Druid.Query.html#mod/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_append/2","doc":"Appends expr to arr, the resulting array type determined by the type of arr.","ref":"Ecto.Druid.Query.html#mv_append/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_concat/2","doc":"Concatenates arr2 to arr1. The resulting array type is determined by the type of arr1.","ref":"Ecto.Druid.Query.html#mv_concat/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_contains/2","doc":"If expr is a scalar type, returns 1 if arr contains expr. If expr is an array, returns 1 if arr contains all elements of expr. Otherwise returns 0.","ref":"Ecto.Druid.Query.html#mv_contains/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_filter_none/2","doc":"Filters multi-value expr to include no values contained in array arr.","ref":"Ecto.Druid.Query.html#mv_filter_none/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_filter_only/2","doc":"Filters multi-value expr to include only values contained in array arr.","ref":"Ecto.Druid.Query.html#mv_filter_only/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_length/1","doc":"Returns length of the array expression.","ref":"Ecto.Druid.Query.html#mv_length/1"},{"type":"macro","title":"Ecto.Druid.Query.mv_offset/2","doc":"Returns the array element at the 0-based index supplied, or null for an out of range index.","ref":"Ecto.Druid.Query.html#mv_offset/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_offset_of/2","doc":"Returns the 0-based index of the first occurrence of expr in the array. If no matching elements exist in the array, returns null or -1 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode).","ref":"Ecto.Druid.Query.html#mv_offset_of/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_ordinal/2","doc":"Returns the array element at the 1-based index supplied, or null for an out of range index.","ref":"Ecto.Druid.Query.html#mv_ordinal/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_ordinal_of/2","doc":"Returns the 1-based index of the first occurrence of expr in the array. If no matching elements exist in the array, returns null or -1 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode).","ref":"Ecto.Druid.Query.html#mv_ordinal_of/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_overlap/2","doc":"Returns 1 if arr1 and arr2 have any elements in common, else 0.","ref":"Ecto.Druid.Query.html#mv_overlap/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_prepend/2","doc":"Adds expr to the beginning of arr, the resulting array type determined by the type of arr.","ref":"Ecto.Druid.Query.html#mv_prepend/2"},{"type":"macro","title":"Ecto.Druid.Query.mv_slice/3","doc":"Returns the subarray of arr from the 0-based index start(inclusive) to end(exclusive), or null, if start is less than 0, greater than length of arr or greater than end.","ref":"Ecto.Druid.Query.html#mv_slice/3"},{"type":"macro","title":"Ecto.Druid.Query.mv_to_array/1","doc":"Converts a multi-value string from a VARCHAR to a VARCHAR ARRAY.","ref":"Ecto.Druid.Query.html#mv_to_array/1"},{"type":"macro","title":"Ecto.Druid.Query.mv_to_string/2","doc":"Joins all elements of arr by the delimiter specified by str.","ref":"Ecto.Druid.Query.html#mv_to_string/2"},{"type":"macro","title":"Ecto.Druid.Query.nullif/2","doc":"Returns NULL if value1 and value2 match, else returns value1.","ref":"Ecto.Druid.Query.html#nullif/2"},{"type":"macro","title":"Ecto.Druid.Query.nvl/2","doc":"Returns value1 if value1 is not null, otherwise value2.","ref":"Ecto.Druid.Query.html#nvl/2"},{"type":"macro","title":"Ecto.Druid.Query.parse_json/1","doc":"Parses expr into a COMPLEX  object. This operator deserializes JSON values when processing them, translating stringified JSON into a nested structure. If the input is not a VARCHAR or it is invalid JSON, this function will result in an error.","ref":"Ecto.Druid.Query.html#parse_json/1"},{"type":"macro","title":"Ecto.Druid.Query.parse_long/1","doc":"Parses a string into a long (BIGINT) with the given radix, or 10 (decimal) if a radix is not provided.","ref":"Ecto.Druid.Query.html#parse_long/1"},{"type":"macro","title":"Ecto.Druid.Query.parse_long/2","doc":"Parses a string into a long (BIGINT) with the given radix, or 10 (decimal) if a radix is not provided.","ref":"Ecto.Druid.Query.html#parse_long/2"},{"type":"macro","title":"Ecto.Druid.Query.pi/0","doc":"Constant Pi.","ref":"Ecto.Druid.Query.html#pi/0"},{"type":"macro","title":"Ecto.Druid.Query.position/2","doc":"Returns the index of needle within haystack, with indexes starting from 1. The search will begin at fromIndex, or 1 if fromIndex is not specified. If needle is not found, returns 0.","ref":"Ecto.Druid.Query.html#position/2"},{"type":"macro","title":"Ecto.Druid.Query.position/3","doc":"Returns the index of needle within haystack, with indexes starting from 1. The search will begin at fromIndex, or 1 if fromIndex is not specified. If needle is not found, returns 0.","ref":"Ecto.Druid.Query.html#position/3"},{"type":"macro","title":"Ecto.Druid.Query.power/2","doc":"expr raised to the power of power.","ref":"Ecto.Druid.Query.html#power/2"},{"type":"macro","title":"Ecto.Druid.Query.radians/1","doc":"Converts an angle measured in degrees to an approximately equivalent angle measured in radians.","ref":"Ecto.Druid.Query.html#radians/1"},{"type":"macro","title":"Ecto.Druid.Query.regexp_extract/2","doc":"Apply regular expression pattern to expr and extract a capture group, or NULL if there is no match. If index is unspecified or zero, returns the first substring that matched the pattern. The pattern may match anywhere inside expr; if you want to match the entire string instead, use the ^ and $ markers at the start and end of your pattern. Note: when druid.generic.useDefaultValueForNull = true, it is not possible to differentiate an empty-string match from a non-match (both will return NULL).","ref":"Ecto.Druid.Query.html#regexp_extract/2"},{"type":"macro","title":"Ecto.Druid.Query.regexp_extract/3","doc":"Apply regular expression pattern to expr and extract a capture group, or NULL if there is no match. If index is unspecified or zero, returns the first substring that matched the pattern. The pattern may match anywhere inside expr; if you want to match the entire string instead, use the ^ and $ markers at the start and end of your pattern. Note: when druid.generic.useDefaultValueForNull = true, it is not possible to differentiate an empty-string match from a non-match (both will return NULL).","ref":"Ecto.Druid.Query.html#regexp_extract/3"},{"type":"macro","title":"Ecto.Druid.Query.regexp_like/2","doc":"Returns whether expr matches regular expression pattern. The pattern may match anywhere inside expr; if you want to match the entire string instead, use the ^ and $ markers at the start and end of your pattern. Similar to LIKE, but uses regexps instead of LIKE patterns. Especially useful in WHERE clauses.","ref":"Ecto.Druid.Query.html#regexp_like/2"},{"type":"macro","title":"Ecto.Druid.Query.regexp_replace/3","doc":"Replaces all occurrences of regular expression pattern within expr with replacement. The replacement string may refer to capture groups using $1, $2, etc. The pattern may match anywhere inside expr; if you want to match the entire string instead, use the ^ and $ markers at the start and end of your pattern.","ref":"Ecto.Druid.Query.html#regexp_replace/3"},{"type":"macro","title":"Ecto.Druid.Query.repeat/2","doc":"Repeats expr N times.","ref":"Ecto.Druid.Query.html#repeat/2"},{"type":"macro","title":"Ecto.Druid.Query.replace/3","doc":"Replaces pattern with replacement in expr, and returns the result.","ref":"Ecto.Druid.Query.html#replace/3"},{"type":"macro","title":"Ecto.Druid.Query.reverse/1","doc":"Reverses expr.","ref":"Ecto.Druid.Query.html#reverse/1"},{"type":"macro","title":"Ecto.Druid.Query.right/1","doc":"Returns the rightmost length characters from expr.","ref":"Ecto.Druid.Query.html#right/1"},{"type":"macro","title":"Ecto.Druid.Query.right/2","doc":"Returns the rightmost length characters from expr.","ref":"Ecto.Druid.Query.html#right/2"},{"type":"macro","title":"Ecto.Druid.Query.round/1","doc":"ROUND(x, y) would return the value of the x rounded to the y decimal places.","ref":"Ecto.Druid.Query.html#round/1"},{"type":"macro","title":"Ecto.Druid.Query.round/2","doc":"ROUND(x, y) would return the value of the x rounded to the y decimal places.","ref":"Ecto.Druid.Query.html#round/2"},{"type":"macro","title":"Ecto.Druid.Query.rpad/2","doc":"Returns a string of length from expr right-padded with chars. If length is shorter than the length of expr, the result is expr which is truncated to length. The result will be null if either expr or chars is null. If chars is an empty string, no padding is added, however expr may be trimmed if necessary.","ref":"Ecto.Druid.Query.html#rpad/2"},{"type":"macro","title":"Ecto.Druid.Query.rpad/3","doc":"Returns a string of length from expr right-padded with chars. If length is shorter than the length of expr, the result is expr which is truncated to length. The result will be null if either expr or chars is null. If chars is an empty string, no padding is added, however expr may be trimmed if necessary.","ref":"Ecto.Druid.Query.html#rpad/3"},{"type":"macro","title":"Ecto.Druid.Query.rtrim/1","doc":"Alternate form of TRIM(TRAILING chars FROM expr).","ref":"Ecto.Druid.Query.html#rtrim/1"},{"type":"macro","title":"Ecto.Druid.Query.rtrim/2","doc":"Alternate form of TRIM(TRAILING chars FROM expr).","ref":"Ecto.Druid.Query.html#rtrim/2"},{"type":"macro","title":"Ecto.Druid.Query.safe_divide/2","doc":"Returns the division of x by y guarded on division by 0.","ref":"Ecto.Druid.Query.html#safe_divide/2"},{"type":"macro","title":"Ecto.Druid.Query.sin/1","doc":"Trigonometric sine of an angle expr.","ref":"Ecto.Druid.Query.html#sin/1"},{"type":"macro","title":"Ecto.Druid.Query.sql_case/1","doc":"Searched CASE.","ref":"Ecto.Druid.Query.html#sql_case/1"},{"type":"macro","title":"Ecto.Druid.Query.sql_case/2","doc":"Simple CASE.","ref":"Ecto.Druid.Query.html#sql_case/2"},{"type":"macro","title":"Ecto.Druid.Query.sqrt/1","doc":"Square root.","ref":"Ecto.Druid.Query.html#sqrt/1"},{"type":"macro","title":"Ecto.Druid.Query.stddev/1","doc":"Computes standard deviation sample of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#stddev/1"},{"type":"macro","title":"Ecto.Druid.Query.stddev_pop/1","doc":"Computes standard deviation population of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#stddev_pop/1"},{"type":"macro","title":"Ecto.Druid.Query.stddev_samp/1","doc":"Computes standard deviation sample of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#stddev_samp/1"},{"type":"macro","title":"Ecto.Druid.Query.string_agg/1","doc":"Collects all values (or all distinct values) of expr into a single STRING, ignoring null values. Each value is joined by an optional separator, which must be a literal STRING. If the separator is not provided, strings are concatenated without a separator. An optional size in bytes can be supplied to limit aggregation size (default of 1024 bytes). If the aggregated string grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the STRING_AGG expression is not currently supported, and the ordering of results within the output string may vary depending on processing order.","ref":"Ecto.Druid.Query.html#string_agg/1"},{"type":"macro","title":"Ecto.Druid.Query.string_agg/2","doc":"Collects all values (or all distinct values) of expr into a single STRING, ignoring null values. Each value is joined by an optional separator, which must be a literal STRING. If the separator is not provided, strings are concatenated without a separator. An optional size in bytes can be supplied to limit aggregation size (default of 1024 bytes). If the aggregated string grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the STRING_AGG expression is not currently supported, and the ordering of results within the output string may vary depending on processing order.\n\nAn optional size in bytes can be supplied to limit aggregation size (default of 1024 bytes). If the aggregated string grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the STRING_AGG expression is not currently supported, and the ordering of results within the output string may vary depending on processing order.\tnull or '' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#string_agg/2"},{"type":"macro","title":"Ecto.Druid.Query.string_agg/3","doc":"Collects all values (or all distinct values) of expr into a single STRING, ignoring null values. Each value is joined by an optional separator, which must be a literal STRING. If the separator is not provided, strings are concatenated without a separator. An optional size in bytes can be supplied to limit aggregation size (default of 1024 bytes). If the aggregated string grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the STRING_AGG expression is not currently supported, and the ordering of results within the output string may vary depending on processing order.\n\nAn optional size in bytes can be supplied to limit aggregation size (default of 1024 bytes). If the aggregated string grows larger than the maximum size in bytes, the query will fail. Use of ORDER BY within the STRING_AGG expression is not currently supported, and the ordering of results within the output string may vary depending on processing order.\tnull or '' if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#string_agg/3"},{"type":"macro","title":"Ecto.Druid.Query.string_format/2","doc":"Returns a string formatted in the manner of Java's String.format.","ref":"Ecto.Druid.Query.html#string_format/2"},{"type":"macro","title":"Ecto.Druid.Query.string_to_array/2","doc":"Splits str1 into an array on the delimiter specified by str2, which is a regular expression.","ref":"Ecto.Druid.Query.html#string_to_array/2"},{"type":"macro","title":"Ecto.Druid.Query.string_to_mv/2","doc":"Splits str1 into an array on the delimiter specified by str2, which is a regular expression.","ref":"Ecto.Druid.Query.html#string_to_mv/2"},{"type":"macro","title":"Ecto.Druid.Query.strlen/1","doc":"Alias for LENGTH.","ref":"Ecto.Druid.Query.html#strlen/1"},{"type":"macro","title":"Ecto.Druid.Query.strpos/2","doc":"Returns the index of needle within haystack, with indexes starting from 1. If needle is not found, returns 0.","ref":"Ecto.Druid.Query.html#strpos/2"},{"type":"macro","title":"Ecto.Druid.Query.substr/2","doc":"Alias for SUBSTRING.","ref":"Ecto.Druid.Query.html#substr/2"},{"type":"macro","title":"Ecto.Druid.Query.substr/3","doc":"Alias for SUBSTRING.","ref":"Ecto.Druid.Query.html#substr/3"},{"type":"macro","title":"Ecto.Druid.Query.substring/2","doc":"Returns a substring of expr starting at index, with a max length, both measured in UTF-16 code units.","ref":"Ecto.Druid.Query.html#substring/2"},{"type":"macro","title":"Ecto.Druid.Query.substring/3","doc":"Returns a substring of expr starting at index, with a max length, both measured in UTF-16 code units.","ref":"Ecto.Druid.Query.html#substring/3"},{"type":"macro","title":"Ecto.Druid.Query.table/1","doc":"","ref":"Ecto.Druid.Query.html#table/1"},{"type":"macro","title":"Ecto.Druid.Query.tan/1","doc":"Trigonometric tangent of an angle expr.","ref":"Ecto.Druid.Query.html#tan/1"},{"type":"macro","title":"Ecto.Druid.Query.tdigest_generate_sketch/1","doc":"Builds a T-Digest sketch on values produced by expr. Compression parameter (default value 100) determines the accuracy and size of the sketch Higher compression means higher accuracy but more space to store sketches.","ref":"Ecto.Druid.Query.html#tdigest_generate_sketch/1"},{"type":"macro","title":"Ecto.Druid.Query.tdigest_generate_sketch/2","doc":"Builds a T-Digest sketch on values produced by expr. Compression parameter (default value 100) determines the accuracy and size of the sketch Higher compression means higher accuracy but more space to store sketches.","ref":"Ecto.Druid.Query.html#tdigest_generate_sketch/2"},{"type":"macro","title":"Ecto.Druid.Query.tdigest_quantile/2","doc":"Builds a T-Digest sketch on values produced by expr and returns the value for the quantile. Compression parameter (default value 100) determines the accuracy and size of the sketch. Higher compression means higher accuracy but more space to store sketches.","ref":"Ecto.Druid.Query.html#tdigest_quantile/2"},{"type":"macro","title":"Ecto.Druid.Query.tdigest_quantile/3","doc":"Builds a T-Digest sketch on values produced by expr and returns the value for the quantile. Compression parameter (default value 100) determines the accuracy and size of the sketch. Higher compression means higher accuracy but more space to store sketches.","ref":"Ecto.Druid.Query.html#tdigest_quantile/3"},{"type":"macro","title":"Ecto.Druid.Query.textcat/2","doc":"Two argument version of CONCAT.","ref":"Ecto.Druid.Query.html#textcat/2"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_estimate/1","doc":"Returns the distinct count estimate from a theta sketch. expr must return a theta sketch.","ref":"Ecto.Druid.Query.html#theta_sketch_estimate/1"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_estimate_with_error_bounds/2","doc":"Returns the distinct count estimate and error bounds from a theta sketch. expr must return a theta sketch.","ref":"Ecto.Druid.Query.html#theta_sketch_estimate_with_error_bounds/2"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_intersect/1","doc":"Returns an intersection of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_intersect/1"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_intersect/2","doc":"Returns an intersection of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_intersect/2"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_not/1","doc":"Returns a set difference of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_not/1"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_not/2","doc":"Returns a set difference of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_not/2"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_union/1","doc":"Returns a union of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_union/1"},{"type":"macro","title":"Ecto.Druid.Query.theta_sketch_union/2","doc":"Returns a union of theta sketches, where each input expression must return a theta sketch. The size can be optionally specified as the first parameter.","ref":"Ecto.Druid.Query.html#theta_sketch_union/2"},{"type":"macro","title":"Ecto.Druid.Query.time_ceil/2","doc":"Rounds up a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_CEIL(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to CEIL but is more flexible.","ref":"Ecto.Druid.Query.html#time_ceil/2"},{"type":"macro","title":"Ecto.Druid.Query.time_ceil/3","doc":"Rounds up a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_CEIL(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to CEIL but is more flexible.","ref":"Ecto.Druid.Query.html#time_ceil/3"},{"type":"macro","title":"Ecto.Druid.Query.time_ceil/4","doc":"Rounds up a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_CEIL(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to CEIL but is more flexible.","ref":"Ecto.Druid.Query.html#time_ceil/4"},{"type":"macro","title":"Ecto.Druid.Query.time_extract/2","doc":"Extracts a time part from expr, returning it as a number. Unit can be EPOCH, SECOND, MINUTE, HOUR, DAY (day of month), DOW (day of week), DOY (day of year), WEEK (week of week year), MONTH (1 through 12), QUARTER (1 through 4), or YEAR. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to EXTRACT but is more flexible. Unit and time zone must be literals, and must be provided quoted, like TIME_EXTRACT(__time, 'HOUR') or TIME_EXTRACT(__time, 'HOUR', 'America/Los_Angeles').","ref":"Ecto.Druid.Query.html#time_extract/2"},{"type":"macro","title":"Ecto.Druid.Query.time_extract/3","doc":"Extracts a time part from expr, returning it as a number. Unit can be EPOCH, SECOND, MINUTE, HOUR, DAY (day of month), DOW (day of week), DOY (day of year), WEEK (week of week year), MONTH (1 through 12), QUARTER (1 through 4), or YEAR. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to EXTRACT but is more flexible. Unit and time zone must be literals, and must be provided quoted, like TIME_EXTRACT(__time, 'HOUR') or TIME_EXTRACT(__time, 'HOUR', 'America/Los_Angeles').","ref":"Ecto.Druid.Query.html#time_extract/3"},{"type":"macro","title":"Ecto.Druid.Query.time_floor/2","doc":"Rounds down a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_FLOOR(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to FLOOR but is more flexible.","ref":"Ecto.Druid.Query.html#time_floor/2"},{"type":"macro","title":"Ecto.Druid.Query.time_floor/3","doc":"Rounds down a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_FLOOR(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to FLOOR but is more flexible.","ref":"Ecto.Druid.Query.html#time_floor/3"},{"type":"macro","title":"Ecto.Druid.Query.time_floor/4","doc":"Rounds down a timestamp, returning it as a new timestamp. Period can be any ISO8601 period, like P3M (quarters) or PT12H (half-days). Specify origin as a timestamp to set the reference time for rounding. For example, TIME_FLOOR(__time, 'PT1H', TIMESTAMP '2016-06-27 00:30:00') measures an hourly period from 00:30-01:30 instead of 00:00-01:00. See Period granularities for details on the default starting boundaries. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. This function is similar to FLOOR but is more flexible.","ref":"Ecto.Druid.Query.html#time_floor/4"},{"type":"macro","title":"Ecto.Druid.Query.time_format/1","doc":"Formats a timestamp as a string with a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. Pattern and time zone must be literals.","ref":"Ecto.Druid.Query.html#time_format/1"},{"type":"macro","title":"Ecto.Druid.Query.time_format/2","doc":"Formats a timestamp as a string with a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. Pattern and time zone must be literals.","ref":"Ecto.Druid.Query.html#time_format/2"},{"type":"macro","title":"Ecto.Druid.Query.time_format/3","doc":"Formats a timestamp as a string with a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'. Pattern and time zone must be literals.","ref":"Ecto.Druid.Query.html#time_format/3"},{"type":"macro","title":"Ecto.Druid.Query.time_in_interval/2","doc":"Returns whether a timestamp is contained within a particular interval. The interval must be a literal string containing any ISO8601 interval, such as '2001-01-01/P1D' or '2001-01-01T01:00:00/2001-01-02T01:00:00'. The start instant of the interval is inclusive and the end instant is exclusive.","ref":"Ecto.Druid.Query.html#time_in_interval/2"},{"type":"macro","title":"Ecto.Druid.Query.time_parse/1","doc":"Parses a string into a timestamp using a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00', and will be used as the time zone for strings that do not include a time zone offset. Pattern and time zone must be literals. Strings that cannot be parsed as timestamps will be returned as NULL.","ref":"Ecto.Druid.Query.html#time_parse/1"},{"type":"macro","title":"Ecto.Druid.Query.time_parse/2","doc":"Parses a string into a timestamp using a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00', and will be used as the time zone for strings that do not include a time zone offset. Pattern and time zone must be literals. Strings that cannot be parsed as timestamps will be returned as NULL.","ref":"Ecto.Druid.Query.html#time_parse/2"},{"type":"macro","title":"Ecto.Druid.Query.time_parse/3","doc":"Parses a string into a timestamp using a given Joda DateTimeFormat pattern, or ISO8601 (e.g. 2000-01-02T03:04:05Z) if the pattern is not provided. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00', and will be used as the time zone for strings that do not include a time zone offset. Pattern and time zone must be literals. Strings that cannot be parsed as timestamps will be returned as NULL.","ref":"Ecto.Druid.Query.html#time_parse/3"},{"type":"macro","title":"Ecto.Druid.Query.time_shift/3","doc":"Shifts a timestamp by a period (step times), returning it as a new timestamp. Period can be any ISO8601 period. Step may be negative. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'.","ref":"Ecto.Druid.Query.html#time_shift/3"},{"type":"macro","title":"Ecto.Druid.Query.time_shift/4","doc":"Shifts a timestamp by a period (step times), returning it as a new timestamp. Period can be any ISO8601 period. Step may be negative. The time zone, if provided, should be a time zone name like 'America/Los_Angeles' or offset like '-08:00'.","ref":"Ecto.Druid.Query.html#time_shift/4"},{"type":"macro","title":"Ecto.Druid.Query.timestamp_to_millis/1","doc":"Converts a timestamp into a number of milliseconds since the epoch.","ref":"Ecto.Druid.Query.html#timestamp_to_millis/1"},{"type":"macro","title":"Ecto.Druid.Query.timestampadd/3","doc":"Equivalent to timestamp + count * INTERVAL '1' UNIT.","ref":"Ecto.Druid.Query.html#timestampadd/3"},{"type":"macro","title":"Ecto.Druid.Query.timestampdiff/3","doc":"Returns the (signed) number of unit between timestamp1 and timestamp2. Unit can be SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or YEAR.","ref":"Ecto.Druid.Query.html#timestampdiff/3"},{"type":"macro","title":"Ecto.Druid.Query.to_json_string/1","doc":"Serializes expr into a JSON string.","ref":"Ecto.Druid.Query.html#to_json_string/1"},{"type":"macro","title":"Ecto.Druid.Query.trim/1","doc":"Returns expr with characters removed from the leading, trailing, or both ends of expr if they are in chars. If chars is not provided, it defaults to '' (a space). If the directional argument is not provided, it defaults to BOTH.","ref":"Ecto.Druid.Query.html#trim/1"},{"type":"macro","title":"Ecto.Druid.Query.trim/2","doc":"Returns expr with characters removed from the leading, trailing, or both ends of expr if they are in chars. If chars is not provided, it defaults to '' (a space). If the directional argument is not provided, it defaults to BOTH.","ref":"Ecto.Druid.Query.html#trim/2"},{"type":"macro","title":"Ecto.Druid.Query.trunc/1","doc":"Alias for TRUNCATE.","ref":"Ecto.Druid.Query.html#trunc/1"},{"type":"macro","title":"Ecto.Druid.Query.trunc/2","doc":"Alias for TRUNCATE.","ref":"Ecto.Druid.Query.html#trunc/2"},{"type":"macro","title":"Ecto.Druid.Query.truncate/1","doc":"Truncate expr to a specific number of decimal digits.","ref":"Ecto.Druid.Query.html#truncate/1"},{"type":"macro","title":"Ecto.Druid.Query.truncate/2","doc":"Truncate expr to a specific number of decimal digits.","ref":"Ecto.Druid.Query.html#truncate/2"},{"type":"macro","title":"Ecto.Druid.Query.try_parse_json/1","doc":"Parses expr into a COMPLEX  object. This operator deserializes JSON values when processing them, translating stringified JSON into a nested structure. If the input is not a VARCHAR or it is invalid JSON, this function will result in a NULL value.","ref":"Ecto.Druid.Query.html#try_parse_json/1"},{"type":"macro","title":"Ecto.Druid.Query.upper/1","doc":"Returns expr in all uppercase.","ref":"Ecto.Druid.Query.html#upper/1"},{"type":"macro","title":"Ecto.Druid.Query.var_pop/1","doc":"Computes variance population of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#var_pop/1"},{"type":"macro","title":"Ecto.Druid.Query.var_samp/1","doc":"Computes variance sample of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#var_samp/1"},{"type":"macro","title":"Ecto.Druid.Query.variance/1","doc":"Computes variance sample of expr. See stats extension documentation for additional details.\tnull or 0 if druid.generic.useDefaultValueForNull=true (deprecated legacy mode)","ref":"Ecto.Druid.Query.html#variance/1"},{"type":"module","title":"Ecto.Druid.DSHistogram","doc":"An Ecto.Type for encoding/decoding DSHistogram values.","ref":"Ecto.Druid.DSHistogram.html"},{"type":"module","title":"Ecto.Druid.DateTime","doc":"Druid returns dates as strings in ISO8601 format with a time zone. This module provides an Ecto type to cast, load,\nand dump these strings as Elixir DateTime structs.","ref":"Ecto.Druid.DateTime.html"},{"type":"module","title":"Ecto.Druid.HLLSketch","doc":"An Ecto.Type for encoding/decoding HLLSketch values.","ref":"Ecto.Druid.HLLSketch.html"},{"type":"module","title":"Ecto.Druid.QuantilesSketch","doc":"An Ecto.Type for encoding/decoding QuantilesSketch values.","ref":"Ecto.Druid.QuantilesSketch.html"},{"type":"module","title":"Ecto.Druid.ThetaSketch","doc":"An Ecto.Type for encoding/decoding ThetaSketch values.","ref":"Ecto.Druid.ThetaSketch.html"},{"type":"module","title":"Ecto.Druid.TupleSketch","doc":"An Ecto.Type for encoding/decoding TupleSketch values.","ref":"Ecto.Druid.TupleSketch.html"},{"type":"module","title":"Druid.Client","doc":"A client for querying Druid.","ref":"Druid.Client.html"},{"type":"function","title":"Druid.Client.request/2","doc":"Makes a request to Druid.","ref":"Druid.Client.html#request/2"},{"type":"function","title":"Examples - Druid.Client.request/2","doc":"Druid.Client.Task.all()\n    |> Druid.Client.request(host: \"localhost\", port: 8082)","ref":"Druid.Client.html#request/2-examples"},{"type":"function","title":"Druid.Client.request!/2","doc":"Makes a request to Druid.","ref":"Druid.Client.html#request!/2"},{"type":"function","title":"Examples - Druid.Client.request!/2","doc":"Druid.Client.Task.all()\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.html#request!/2-examples"},{"type":"module","title":"Druid.Client.Native","doc":"Builds requests for Druid's native API.","ref":"Druid.Client.Native.html"},{"type":"function","title":"Druid.Client.Native.query/1","doc":"Builds a query request for Druid's native query API.","ref":"Druid.Client.Native.html#query/1"},{"type":"function","title":"Examples - Druid.Client.Native.query/1","doc":"Druid.Client.Native.query(%{\n      queryType: \"timeseries\",\n      dataSource: \"wikipedia\",\n      intervals: [\"2015-09-12T00:00:00.000Z/2015-09-13T00:00:00.000Z\"],\n      granularity: \"all\",\n      aggregations: [\n        %{type: \"count\", name: \"count\"}\n      ]\n    })\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.Native.html#query/1-examples"},{"type":"module","title":"Druid.Client.SQL","doc":"Builds requests for Druid's SQL API.","ref":"Druid.Client.SQL.html"},{"type":"function","title":"Druid.Client.SQL.insert/3","doc":"Builds an insert request for Druid's SQL API.","ref":"Druid.Client.SQL.html#insert/3"},{"type":"function","title":"Examples - Druid.Client.SQL.insert/3","doc":"sql = \"\"\"\n      INSERT INTO w000\n      SELECT\n        TIME_PARSE(\"timestamp\") AS __time,\n        isRobot,\n        channel,\n        flags,\n        isUnpatrolled,\n        page,\n        diffUrl,\n        added,\n        comment,\n        commentLength,\n        isNew,\n        isMinor,\n        delta,\n        isAnonymous,\n        user,\n        deltaBucket,\n        deleted,\n        namespace,\n        cityName,\n        countryName,\n        regionIsoCode,\n        metroCode,\n        countryIsoCode,\n        regionName\n      FROM TABLE(\n          EXTERN(\n            '{\"type\":\"http\",\"uris\":[\"https://druid.apache.org/data/wikipedia.json.gz\"]}',\n            '{\"type\":\"json\"}',\n            '[{\"name\":\"isRobot\",\"type\":\"string\"},{\"name\":\"channel\",\"type\":\"string\"},{\"name\":\"timestamp\",\"type\":\"string\"},{\"name\":\"flags\",\"type\":\"string\"},{\"name\":\"isUnpatrolled\",\"type\":\"string\"},{\"name\":\"page\",\"type\":\"string\"},{\"name\":\"diffUrl\",\"type\":\"string\"},{\"name\":\"added\",\"type\":\"long\"},{\"name\":\"comment\",\"type\":\"string\"},{\"name\":\"commentLength\",\"type\":\"long\"},{\"name\":\"isNew\",\"type\":\"string\"},{\"name\":\"isMinor\",\"type\":\"string\"},{\"name\":\"delta\",\"type\":\"long\"},{\"name\":\"isAnonymous\",\"type\":\"string\"},{\"name\":\"user\",\"type\":\"string\"},{\"name\":\"deltaBucket\",\"type\":\"long\"},{\"name\":\"deleted\",\"type\":\"long\"},{\"name\":\"namespace\",\"type\":\"string\"},{\"name\":\"cityName\",\"type\":\"string\"},{\"name\":\"countryName\",\"type\":\"string\"},{\"name\":\"regionIsoCode\",\"type\":\"string\"},{\"name\":\"metroCode\",\"type\":\"long\"},{\"name\":\"countryIsoCode\",\"type\":\"string\"},{\"name\":\"regionName\",\"type\":\"string\"}]'\n          )\n        )\n      PARTITIONED BY HOUR\n      CLUSTERED BY channel\n      \"\"\"\n\n    Druid.Client.SQL.insert(sql)\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.SQL.html#insert/3-examples"},{"type":"function","title":"Druid.Client.SQL.query/3","doc":"Builds a query request for Druid's SQL API.","ref":"Druid.Client.SQL.html#query/3"},{"type":"function","title":"Examples - Druid.Client.SQL.query/3","doc":"Druid.Client.SQL.query(\"SELECT * FROM wikipedia\")\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.SQL.html#query/3-examples"},{"type":"module","title":"Druid.Client.Task","doc":"Builds requests for Druid's task API.","ref":"Druid.Client.Task.html"},{"type":"function","title":"Druid.Client.Task.all/0","doc":"Builds a request to get all tasks.","ref":"Druid.Client.Task.html#all/0"},{"type":"function","title":"Examples - Druid.Client.Task.all/0","doc":"Druid.Client.Task.all()\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.Task.html#all/0-examples"},{"type":"function","title":"Druid.Client.Task.result/1","doc":"Builds a request to get a task result by ID.","ref":"Druid.Client.Task.html#result/1"},{"type":"function","title":"Examples - Druid.Client.Task.result/1","doc":"Druid.Client.Task.result(\"123\")\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.Task.html#result/1-examples"},{"type":"function","title":"Druid.Client.Task.status/1","doc":"Builds a request to get a task by ID.","ref":"Druid.Client.Task.html#status/1"},{"type":"function","title":"Examples - Druid.Client.Task.status/1","doc":"Druid.Client.Task.get(\"123\")\n    |> Druid.Client.request!(host: \"localhost\", port: 8082)","ref":"Druid.Client.Task.html#status/1-examples"},{"type":"module","title":"Ecto.Druid.ComplexType","doc":"Can be used to define a default implementation for a Druid complex type that implements the Ecto.Type behavior.\nAny Ecto.Type behavior can be overridden by defining the corresponding function in the module that uses this macro.","ref":"Ecto.Druid.ComplexType.html"},{"type":"module","title":"Example - Ecto.Druid.ComplexType","doc":"defmodule MyType do\n      use Ecto.Druid.ComplexType\n    end","ref":"Ecto.Druid.ComplexType.html#module-example"},{"type":"module","title":"Ecto.Druid.Util","doc":"Utility functions to generate SQL fragments.","ref":"Ecto.Druid.Util.html"},{"type":"macro","title":"Ecto.Druid.Util.sql_function/2","doc":"Defines a SQL function that can be used in queries.","ref":"Ecto.Druid.Util.html#sql_function/2"},{"type":"macro","title":"Example - Ecto.Druid.Util.sql_function/2","doc":"defmodule MyApp.Query do\n      import Ecto.Druid.Util\n\n      sql_function :my_function, [:arg1, :arg2], type: :integer\n    end\n\nLook at `Ecto.Druid.Query`'s source for more examples.","ref":"Ecto.Druid.Util.html#sql_function/2-example"},{"type":"function","title":"Ecto.Druid.Util.sql_function_body/5","doc":"Defines a SQL function body that can be used in queries.","ref":"Ecto.Druid.Util.html#sql_function_body/5"},{"type":"function","title":"Example - Ecto.Druid.Util.sql_function_body/5","doc":"defmodule MyApp.Query do\n      defmacro my_function(arg1, arg2) do\n        Ecto.Druid.Util.sql_function_body(\"MY_FUNCTION\", \"?, ?\", [arg1, arg2])\n      end\n    end\n\nLook at `Ecto.Druid.Query`'s source for more examples.","ref":"Ecto.Druid.Util.html#sql_function_body/5-example"},{"type":"exception","title":"Druid.Client.RequestError","doc":"","ref":"Druid.Client.RequestError.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}